#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif
   typedef struct {
                    int * renumber ;
                    int  inner_length ;
                    int  total_length ;
                                  } renumber_type;

int identify_global_indices_in_global_elements(
                                  int * mat_elements,int * renumber_elements
                                 ,int number_of_elements
                                 ,int * mat_index   ,int * renumber_index
                                 ,int number_of_index
                                 ,int * index_reference ,int number_of_entries
                                  );
int identify_global_indices_in_local_elements(
                                  int * mat_elements,int * renumber_elements ,int number_of_elements
                                 ,int * mat_index   ,int * renumber_index ,int number_of_index
                                 ,int * index_reference, int * element_reference ,int number_of_entries
                                  );
void find_subset_of_indices(
                                   int * mat_index
                                  ,int mat_number_of_entries
                                  ,int * mat_elements
                                  ,int mat_number_of_rows
				  ,int * index_reference
				  ,int * element_reference
				  ,int * length_reference
                                  ) ;

int pack_renumbering_index(int * mat_index,int * renumber_index,int mat_number_of_entries,int * packed_renumber_index,int * mapping_elements);
void print_indirect( char string[] , int * array1, int * array2, int length);
void print_aligned( char string[] , int * array1, int * array2, int length);
void print_renumber_type(char string[] , renumber_type renumber);
void print_array( char string[] , int * array, int length);
void print_segmented( char string[] , int * array1,int length1, int * array2, int length2);
int calculate_offsets_from_length_array(int * length_array,int * offset_array,int length);
