#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif
   typedef struct {
                    int length ;
                    int inner_length ;
                    int * index ;
                    double * values ;
                                  } sparse_values_type;
void alloc_sparse_values_type(sparse_values_type * aa, int length, int inner_length) ;
void dealloc_sparse_values_type(sparse_values_type * );
void read_sparse_values_type(sparse_values_type );
void read_sparse_values_type_kernel( int *, double *, int);
void write_sparse_values_type_kernel( int *, double * aa, int length, int inner_length) ;
void write_sparse_values_type(char string[], sparse_values_type aa);
void sparse_values_to_sparse_values_kernel(int *, double *, int *, double *, int);
void sparse_values_to_sparse_values(sparse_values_type , sparse_values_type );
void set_sparse_values(  sparse_values_type * aa, int jmin, int kmin, int jmax, int kmax, int jmx_glob) ;;
void set_sparse_values_kernel(int * index, double * aa, int * length, int * inner_length, int jmin, int kmin, int jmax, int kmax, int jmx_glob) ;
