#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif
   typedef struct {
                    int length ;
                    int inner_length ;
                    double * values ;
                                  } vector_type;
void alloc_vector_type(vector_type * aa, int length, int inner_length) ;
void dealloc_vector_type(vector_type * );
void read_vector_type(vector_type );
void read_vector_type_kernel( double *, int);
void write_vector_type_kernel( double * aa, int length, int inner_length) ;
void write_vector_type(char string[], vector_type aa);
void set_vector_kernel(double *, int, int, int);
void set_vector(  vector_type ,int , int ) ;
void vector_update( vector_type , vector_type , double  ) ;
void vector_update_kernel( double * , double * , double , int) ;
void vector_update_r(vector_type , vector_type , double ) ;
void vector_update_r_kernel(double *, double *, double, int);
void vector_axpy_kernel( double *, double *, double *, double, int);
void vector_axpy( vector_type , vector_type , vector_type , double );
void vector_to_vector_kernel(double *, double *, int);
void vector_to_vector(vector_type , vector_type );
void dotproduct_kernel( double * , double * , double * , int ) ;
void dotproduct( double * , vector_type , vector_type );
void exchange_vector(vector_type , buffer_set, buffer_set);
void exch_vector(exch_set_type * exch_data, vector_type aa
                        ,double * to_buffer_values,   int * to_buffer_index,   int * to_buffer_offset_array,   int * to_buffer_length_array
                        ,double * from_buffer_values, int * from_buffer_index, int * from_buffer_offset_array, int * from_buffer_length_array
                              ) ; 
