#define PATCH_N0 50
#define PATCH_N1 0
#define PATCH_N2 4
#define PATCH_N3 8
#define PATCH_N4 12
#define PATCH_N5 13
   typedef struct {
                    int data[PATCH_N0];
                    int * patch_bounds ;
                    int * global_bounds ;
                    int * math_bounds  ;
                    int * neighbours  ;
                    int * number_proc_neighbours  ;
                                  } patch_type;

void intialize_patch(patch_type * patch);
void print_patch(patch_type  patch);
void partitioning_2D_k(int* number_remain,int * jsize,int ksize,  int * blocks_k );
void calculate_work_distribution(int number,int  jmin,int kmin,int jmax,int kmax,patch_type * patches,int * patches_length);
void communicate_patches(patch_type * patches,patch_type * my_patch, int root);
